#ifndef _PTHREAD_H
#include <pthread/pthread.h>

extern int __pthread_mutex_init (pthread_mutex_t *__mutex,
				 const pthread_mutexattr_t *__attr);
extern int __pthread_mutex_destroy (pthread_mutex_t *__mutex);
extern int __pthread_mutex_lock (pthread_mutex_t *__mutex);
extern int __pthread_mutex_unlock (pthread_mutex_t *__mutex);

extern int __pthread_once (pthread_once_t *__once,
			   void (*__init_routine)(void));

extern int __pthread_key_create (pthread_key_t *__key,
				 void (*__destructor)(void*));
extern int __pthread_setspecific (pthread_key_t __key,
				  const void *__value);
extern void *__pthread_getspecific (pthread_key_t __key);

extern pthread_t __pthread_self (void);

#endif /* pthread.h */
