/* Set and get detachstate attribute.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <errno.h>
#include <pthread.h>

#include <pt-attr.h>

/* Get `detachstate' attribute from *ATTR and return it in *DETACHSTATE.  */
int
pthread_attr_getdetachstate (const pthread_attr_t * attr, int *detachstate)
{
	*detachstate = (*attr)->detachstate;
	return 0;
}

/* Set `detachstate' attribute in *ATTR to DETACHSTATE.  */
int pthread_attr_setdetachstate (pthread_attr_t * attr, int detachstate)
{
	if (detachstate != PTHREAD_CREATE_DETACHED
			&& detachstate != PTHREAD_CREATE_JOINABLE) return EINVAL;

	(*attr)->detachstate = detachstate;
	return 0;
}
