/* Initialize a thread attributes object.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <errno.h>
#include <pthread.h>
#include <stdlib.h>
#include <string.h>

#include <pt-attr.h>

/* Initialize thread attribute object *ATTR with default attributes.  */
int pthread_attr_init (pthread_attr_t * attr)
{
	struct __pthread_attr *new;
	int save_errno = errno;

	new = malloc (sizeof (struct __pthread_attr));

	if (new == NULL) {
		__set_errno (save_errno);
		return ENOMEM;
	}

	memset (new, 0, sizeof (struct __pthread_attr));

	*attr = new;
	return 0;
}
