/* Thread-specific data key deletion.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <ihash.h>
#include <pthread.h>
#include <spin-lock.h>

#include <pt-internal.h>

/* XXX */
#define __ihash_remove	ihash_remove

/* Delete KEY.  */
int pthread_key_delete (pthread_key_t key)
{
	struct pthread_specific *specific;

	__pthread_mutex_lock (&__pthread_key_lock);

	/* Remove the thread-specific data associated with KEY from all
	   active threads.  */
	__spin_lock (&__pthread_specific_lock);
	for (specific = __pthread_specific; specific; specific = specific->next)
		__ihash_remove (specific->ht, key);
	__spin_lock (&__pthread_specific_lock);

	__pthread_key_destructors[key] = PTHREAD_KEY_AVAILABLE;

	__pthread_mutex_unlock (&__pthread_key_lock);
	return 0;
}
