/* Pthread types.  Generic version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#ifndef _BITS_PTHREADTYPES_H
#define _BITS_PTHREADTYPES_H	1

#include <bits/condition.h>

#define __need_pthread_mutex
#include <bits/mutex.h>

#define __need_pthread_once
#include <bits/once.h>


/* The various attribute object types are defined in terms of opaque
   structures.  You are not supposed to now the internals of these
   structures and it is perfectly all-right that they are not defined
   anywhere.  */

/* Used to identify a thread attribute object.  */
typedef struct __pthread_attr pthread_attr_t;

/* Used for condition variables.  */
typedef struct __pthread_cond pthread_cond_t;

/* Used to identify a condition attribute object.  */
typedef struct __pthread_condattr pthread_condattr_t;

/* Used for thread specific data keys.  */
typedef unsigned long int pthread_key_t;

/* Used for mutexes.  */
typedef struct __pthread_mutex pthread_mutex_t;

/* Used to identify a mutex attribute object.  */
typedef struct __pthread_mutexattr pthread_mutexattr_t;

/* Used for dynamic package initialization.  */
typedef struct __pthread_once pthread_once_t;

/* Used to identify a thread.  */
typedef unsigned long int pthread_t;

#endif /* bits/pthreadtypes.h */
