/* Set schedparam attribute.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <errno.h>
#include <pthread.h>
#include <sched.h>

#include <pt-attr.h>

/* Set `schedparam' attribute in *ATTR to PARAM.  */
int
pthread_attr_setschedparam (pthread_attr_t *attr,
		const struct sched_param *param)
{
	if (param == NULL)
		return EINVAL;

	/* sched_prioriy mirrors Mach's thread priorities */
	if (!(0 <= param->sched_priority && param->sched_priority < 32))
		return ENOTSUP;

	*attr->schedparam = *param;
	return 0;
}
