/* Machine dependent pthreads code.  Hurd/i386 version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <stdint.h>
#include <string.h>
#include <hurd/threadvar.h>

#include <pt-internal.h>

static void machdep_init (struct __pthread *thread)
{
	void *threadvars = __hurd_threadvar_location_from_sp (0, NULL);

	/* Make sure we can find the per-thread variables.  */
	__hurd_threadvar_stack_mask = ~(thread->attr.stacksize - 1);
	__hurd_threadvar_stack_offset = (thread->attr.stacksize
			- __hurd_threadvar_max * sizeof (uintptr_t));

	/* And copy them to their new location on the stack.  */
	memcpy (__hurd_threadvar_location_from_sp (0, thread->attr.stackaddr),
			threadvars, _HURD_THREADVAR_MAX * sizeof (uintptr_t));

	(void) &machdep_init;		/* Avoid "defined but not used" warning.  */
}

text_set_element (__pthread_init, machdep_init);
