/* Destroy a thread structure.  Mach version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <assert.h>
#include <pthread.h>
#include <mach.h>

#include <pt-internal.h>

/* Destroy THREAD.  */
void __pthread_destroy (struct __pthread *thread)
{
	kern_return_t err;

	assert ((pthread_t) thread != __pthread_self ());

	err = __mach_port_destroy (__mach_task_self (),
			thread->wakeupmsg.msgh_remote_port);
	assert_perror (err);

	/* Make sure the thread isn't running anymore.  Don't check the
	   return value, since the thread probably does not exist anymore.  */
	__thread_terminate (thread->kernel_thread);
}
