/* Initialize a thread structure.  Mach version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <errno.h>
#include <pthread.h>
#include <mach.h>

#include <pt-internal.h>

/* Initialize THREAD.  */
int __pthread_init (struct __pthread *thread)
{
	kern_return_t err;

	/* Build wakeup message.  */
	thread->wakeupmsg.msgh_bits = MACH_MSGH_BITS (MACH_MSG_TYPE_COPY_SEND, 0);
	thread->wakeupmsg.msgh_size = 0;
	thread->wakeupmsg.msgh_remote_port = __mach_reply_port ();
	thread->wakeupmsg.msgh_local_port = MACH_PORT_NULL;
	thread->wakeupmsg.msgh_seqno = 0;
	thread->wakeupmsg.msgh_id = 0;

	err = __mach_port_insert_right (__mach_task_self (),
			thread->wakeupmsg.msgh_remote_port,
			thread->wakeupmsg.msgh_remote_port,
			MACH_MSG_TYPE_MAKE_SEND);
	if (err)
		return EAGAIN;

	return 0;
}
