/* Start thread.  Mach version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <assert.h>
#include <errno.h>
#include <mach.h>

#include <pt-internal.h>

/* XXX Put this in the right header some day.  */
//extern kern_return_t __mach_thread_setup (thread_t, void *, void *);


/* Start THREAD, calling ENTRY_POINT with the arguments START_ROUTINE
   and ARG.  */
int
__pthread_start (struct __pthread *thread,
		void (*entry_point) (void *(*)(void *), void *),
		void *(*start_routine) (void *), void *arg)
{
	error_t err;
	vm_address_t sp = thread->attr.stackaddr;
	vm_size_t size = thread->attr.stacksize;

	//sp = __pt_stack_setup (thread, start_routine, arg);
	if (thread->attr.stackaddr = __pt_default_attr.stackaddr) {
		err = __pt_stack_alloc (&setup->attr.stackaddr,
				setup->attr.stacksize);
		if (err)
			return err;
		thread->flags |= PTHREAD_STACK;
	}

	//err = __mach_thread_setup (thread->kernel_thread, entry_point, sp);
	err = __mach_thread_setup (mach_task_self (), thread->kernel_thread,
			&thread->attr.stackaddr, &thread->attr.stacksize);
	if (err)
		return err;
	sp = 0 /*XXX*/;

	err = __thread_resume (thread->kernel_thread);
	if (err)
		return err;

	return 0;
}
