/* System dependent pthreads internal defenitions.  Mach version.
   Copyright (C) 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#ifndef _PT_SYSDEP_H
#define _PT_SYSDEP_H	1

#include <pthread.h>
#include <mach.h>

#include <pt-attr.h>

/* The default stack size.  */
#define PTHREAD_STACK_DEFAULT		(2 * 1024 * 1024)

/* System dependent members of `struct pthread'.  */
#define PTHREAD_SYSDEP_MEMBERS                                                \
    mach_msg_header_t wakeupmsg;                                              \
    thread_t kernel_thread;

/* Return a new thread ID for the calling thread.  */
extern pthread_t __pt_self_alloc (void);

/* Set up the the STACK and ENTRY_POINT for kernel thread THREAD */
extern kern_return_t __mach_thread_setup (thread_t thread,
		void (*entry_point) (void *(*)(void *), void *),
		void *stack);

#ifndef _PT_SYSDEP_H_EXTERN_INLINE
# define _PT_SYSDEP_H_EXTERN_INLINE extern __inline
#endif

/* Return the thread ID of the calling thread.  In contrast to
   `pthread_self', this function may be called by bare Mach threads to
   make them cooperate with POSIX threads.  */
_PT_SYSDEP_H_EXTERN_INLINE pthread_t
__mach_pthread_self (void)
{
  pthread_t __thread = __pthread_self ();

  return (__thread ? : __pt_self_alloc ());
}

#endif /* pt-sysdep.h */
